<template>
	<div v-if="state === LegacyState.ByEmail">
		<h1>Link by email address</h1>
		<p>To link a Legacy account by email, simply add an email address to your Vault account in the Identities section above.</p>
		<p>If your account is not being detected you can also link by password.</p>
		<br>
		<button type="button" @click="state = LegacyState.ByPasswd" class="button prime">link by password</button> &nbsp;
		<button type="button" @click="state = LegacyState.Overview" class="button ghost">cancel</button>
	</div>
	<div v-else-if="state === LegacyState.ByPasswd">
		<h1>Link by password</h1>
		<p>Log in to your Legacy account to link it to your Vault account.</p>
		<p>If you are unable to log in, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
		<br>

		<form class="gap-no read_s login" @submit.prevent="logIn">
			<div class="form-box pa_m">
				<label for="username" class="mini-label">User name</label>
				<input v-focus required autocorrect="off" name="username" id="username" ref="username" v-model="user.name" type="text" placeholder="ManaPlus username" minlength="4" maxlength="23" pattern="^[a-zA-Z0-9_]{4,23}$" title="4-23 characters, alphanumeric and underscores" class="input text_l pa_m">
			</div>
			<div class="form-box pa_m">
				<label for="password" class="mini-label">Password</label>
				<input required autocorrect="off" name="password" id="password" ref="password" v-model="user.password" type="password" placeholder="•••••••••" minlength="4" maxlength="23" pattern="^[^\s][^\t\r\n]{2,21}[^\s]$" title="4-23 characters" class="input text_l pa_m">
			</div>
			<button class="button block text_l" type="submit" ref="submit">Log In &rarr;</button>
			<button type="button" @click="state = LegacyState.Overview" class="button block">Cancel</button>
		</form>
	</div>
	<div v-else-if="state === LegacyState.Linked">
		<h1>Successfully linked</h1>
		<p>Your Legacy account has been linked to your Vault account.</p>
		<button type="button" @click="state = LegacyState.Overview" class="button">return</button>
	</div>
	<main v-else-if="state === LegacyState.Error">
		<h1>Error</h1>
		<pre>{{ error }}</pre>
		<p>Please try again later. If the problem persists, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
	</main>
	<main v-else-if="state === LegacyState.Exists">
		<h1>Already linked</h1>
		<p>This Legacy account is already linked to another Vault account.</p>
		<p>If you believe this is an error, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
		<button type="button" @click="state = LegacyState.Overview" class="button">return</button>
	</main>
	<main v-else-if="state === LegacyState.Already">
		<h1>Already owned</h1>
		<p>This Legacy account is already linked to your Vault account.</p>
		<button type="button" @click="state = LegacyState.Overview" class="button">return</button>
	</main>
	<main v-else-if="state === LegacyState.Invalid">
		<h1>Invalid username or password</h1>
		<p>The login credentials you provided do not match any Legacy account.</p>
		<p>If you need assistance, contact <a rel="noopener noreferrer" href="https://www.themanaworld.org/support">Support</a>.</p>
		<button type="button" @click="state = LegacyState.ByPasswd" class="button">try again</button> &nbsp;
		<button type="button" @click="state = LegacyState.Overview" class="button ghost">cancel</button>
	</main>
	<div v-else>
		<h1>{{ title }}</h1>
		<p>
			Accounts used to log in to The Mana World Legacy. This is to use one of
            the nicknames parked in 2019, if you don't have a parked nickname, then
            you do not need to use this.
		</p>
		<div class="accountContainer">
			<LegacyAccountCard class="box" v-for="(account, key) in accounts" :acc="account" :key="key"/>
			<div class="link-account box">
				<span>Link account</span>
				<button type="button" @click="state = LegacyState.ByEmail" class="button">by email</button>
				<br>
				<button type="button" @click="state = LegacyState.ByPasswd" class="button">by password</button>
			</div>
		</div>
	</div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from "vue-property-decorator"
import LegacyAccountCard from "@/components/LegacyAccountCard.vue"

enum LegacyState {
	Overview, // initial state
	ByEmail,  // link by email
	ByPasswd, // link by password
	Linked,   // successfully linked
	Error,    // misc error
	Invalid,  // invalid password
	Exists,   // already assigned to another user
	Already,  // user already owns this
	TooMany,  // too many linked accounts
}

@Component({
	data () {
		return { LegacyState }
	},
	components: {
		LegacyAccountCard,
	},
	computed: {
		accounts () {
			return this.$store.state.legacyAccounts
		},
	},
})
export default class LegacyAccounts extends Vue {
	@Prop() private title!: string
	state = LegacyState.Overview
	error = ""
	user = {
		name: "",
		password: "",
	}

	async created () {
		return await this.getAccounts()
	}

	async getAccounts () {
		// TODO: send an etag so that the api can say if the data is unchanged and avoid re-sending it
		const req = new Request(`${process.env.VUE_APP_API}/vault/legacy/account`, {
			method: "GET",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"X-VAULT-SESSION": this.$store.state.session.sessionKey,
				"X-VAULT-TOKEN": this.$store.state.session.secretKey,
			},
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			console.error(err)
			// TODO: actually handle this
			return
		}

		const json = await rawResponse.json()

		if (Reflect.has(json, "session")) {
			this.$store.commit("expiry", json.session.expires)
		}

		switch (rawResponse.status) {
		default:
			// TODO: handle errors
			break
		case 200:
			this.$store.commit("setLegacyAccounts", json.accounts)
			return
		case 410:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		}
	}

	async logIn () {
		// check if already owned
		for (const acc of this.$store.state.legacyAccounts) {
			if (acc.name === this.user.name) { // TODO: check whether it's case-insensitive
				this.state = LegacyState.Already
				break
			}
		}

		const submit = this.$refs.submit as HTMLButtonElement
		submit.disabled = true

		const req = new Request(`${process.env.VUE_APP_API}/vault/legacy/account`, {
			method: "POST",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"Content-Type": "application/json",
				"X-VAULT-SESSION": this.$store.state.session.sessionKey,
				"X-VAULT-TOKEN": this.$store.state.session.secretKey,
			},
			body: JSON.stringify({
				username: this.user.name,
				password: this.user.password,
			}),
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			this.state = LegacyState.Error
			this.error = "Couldn't reach the API"
			console.error(err)
			return
		}

		const json = await rawResponse.json()

		if (Reflect.has(json, "session")) {
			this.$store.commit("expiry", json.session.expires)
		}

		submit.disabled = false

		switch (rawResponse.status) {
		case 200:
			if (Reflect.has(json, "accounts")) {
				this.$store.commit("setLegacyAccounts", json.accounts)
			} else if (Reflect.has(json, "account")) {
				this.$store.commit("pushLegacyAccount", json.account)
			} else {
				// ask the server to re-send the accounts
				await this.getAccounts()
			}
			this.state = LegacyState.Linked
			return
		case 404:
			this.state = LegacyState.Invalid
			break
		case 401:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 409:
			this.state = LegacyState.Exists
			break
		case 410:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 416:
			this.state = LegacyState.TooMany
			break
		//case 425:
		case 429:
			this.state = LegacyState.Error
			this.error = "Too many requests"
			return
		case 500:
			this.state = LegacyState.Error
			this.error = "Internal server error"
			return
		case 502:
			this.state = LegacyState.Error
			this.error = "The API is unreachable"
			return
		default:
			this.state = LegacyState.Error
			this.error = `Unknown error: ${rawResponse.status}`
			return
		}
	}
}
</script>

<style scoped>
	.accountContainer {
		display: grid;
		margin-top: 1em;
		grid-auto-rows: auto;
		grid-gap: 1rem;
		grid-template-columns: repeat(auto-fill, 250px);
	}

	.link-account {
		background: var(--main-1);
		box-shadow: 0 4px 8px 0 rgba(0,0,0,0.2);
		margin: 0;
		padding: .8rem;
		display: flex;
		flex-direction: column;
		flex-wrap: wrap;

		& span {
			font-size: 1.2em;
			margin-bottom: .5rem;
		}

		& button {
			width: 100%;
			padding: 1rem;
			margin: auto;
		}
	}
</style>
